#ifndef FIRE_H
#define FIRE_H
namespace sd
{
class Fire
{
private:
	BITMAP *bitmap; //Where the Image Will Be Stored
	BITMAP *fire_disp; //A Sub-bitmap for Displaying the fire only
	PALETTE pal;
	int height;
	int width;
	int color_start; //So can work with nearly any palette
	int color_end;   //Where the colours end, white is color start, black is end
	int num_colors;
	//New Variables, internal use
	int x_increase; //For Setting Bottom Colours
	int color_bright; //To Calculate the bright colours
	float color_speed;
	//The Following routines in C++ would be PRIVATE
	//void update_fire_mode_1(FIRE *fire);
public:
	Fire(int width,int height, int colorstart = 0,int colorend = 255,RGB *p =NULL);
	~Fire();
	void destroy_fire(); //deletes fire
	void create_fire(int width, int height, int colorstart = 0, int colorend =255,RGB *p =NULL);
	void update_fire();
	void draw_fire(BITMAP *dest, int x, int y); //blits the fire

};
}
#endif
